/*****************************************************************************
 *
 * Program Name:  IPX for OS/2 Requester.
 *
 * Filename:	  ipxcalls.h
 *
 * Date Created:  April 26, 1988
 *
 * Version:		  1.0
 *
 * Programmers:	  Kevin Kingdon, Bart Wise
 *
 * Files used:
 *
 * Date Modified: 
 *
 * Modifications: 
 *
 * Comments:	  IPX header file for 'C' interface.
 *
 * COPYRIGHT (c) 1989 by Novell, Inc.  All Rights Reserved.
 *
 * This program is an unpublished copyrighted work which is proprietary
 * to Novell, Inc. and contains confidential information that is not
 * to be reproduced or disclosed to any other person or entity without
 * prior written consent from Novell, Inc. in each and every instance.
 *
 * WARNING:  Unauthorized reproduction of this program as well as
 * unauthorized preparation of derivative works based upon the
 * program or distribution of copies by sale, rental, lease or
 * lending are violations of federal copyright laws and state trade
 * secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/


/*-------------------------------------------------------------------------
 *	Constants.
 */
#define IPXCALLS_INCLUDED

#ifndef NWCALDEF_INC
#include <nwcaldef.h>
#endif

/*-------------------------------------------------------------------------
 *	Type definitions.
 */
typedef struct
{
	void NWPTR fragAddress;
	UINT16 fragSize;
} ECBFrag;

typedef struct IPX_ECBStruct
{
	struct IPX_ECBStruct NWPTR next;
	struct IPX_ECBStruct NWPTR prev;
	UINT16 					status;
	long						reserved1;
	UINT16					lProtID;
	unsigned char				protID[6];
	UINT16					boardNumber;
	unsigned char				immediateAddress[6];
	unsigned char				driverWS[4];
	unsigned char				protocolWS[8];
	UINT16					dataLen;
	UINT16					fragCount;
	ECBFrag						fragList[2];
}IPX_ECB;

typedef struct
{
    UINT16	    checksum;
    UINT16	    packetLen;		    /* Hi-lo. */
    unsigned char   transportCtl;
    unsigned char   packetType;
    unsigned long   destNet;
    unsigned char   destNode[6];
    UINT16	    destSocket;
    unsigned long   sourceNet;
    unsigned char   sourceNode[6];
    UINT16	    sourceSocket;
}IPX_HEADER;

/*-------------------------------------------------------------------------
 *	IPX function prototypes.
 */
extern USHORT NWAPI IpxCheckReceive(USHORT	usSocket);
extern USHORT NWAPI IpxCheckSocket(USHORT	usSocket);
extern USHORT NWAPI IpxCloseSocket(USHORT	usSocket);
extern USHORT NWAPI IpxConnect(IPX_ECB NWPTR ecb);
extern USHORT NWAPI IpxDisconnect(IPX_ECB NWPTR ecb);
extern USHORT NWAPI IpxGetInternetworkAddress(unsigned char NWPTR	puchAddress);
extern USHORT NWAPI IpxGetLocalTarget(unsigned char NWPTR		puchTarget,
										   IPX_ECB NWPTR ecb,
											ULONG NWPTR		pulTimeToNet);
extern USHORT NWAPI IpxGetStatistics(unsigned char NWPTR	puchBuffer);
extern USHORT NWAPI IpxGetVersion(unsigned char NWPTR	puchMajorVersion,
									   unsigned char NWPTR	puchMinorVersion,
									   unsigned char NWPTR	puchRevision);
extern USHORT NWAPI IpxOpenSocket(USHORT NWPTR usSocket);
extern USHORT NWAPI IpxReceive(USHORT			usSocket,
							 		ULONG			ulTimeout,
							 		IPX_ECB  	NWPTR ecb);
extern USHORT NWAPI IpxSend(USHORT			usSocket,
								 IPX_ECB 	NWPTR ecb);

/*=========================================================================*/
