/****************************************************************************
 *
 * (C) Unpublished Copyright of Novell, Inc.  All Rights Reserved.
 *
 * No part of this file may be duplicated, revised, translated, localized
 * or modified in any manner or compiled, linked or uploaded or downloaded
 * to or from any computer system without the prior written permission of
 * Novell, Inc.
 *
 ****************************************************************************/

#ifndef	_NWDSDSA_HEADER_
#define	_NWDSDSA_HEADER_

#ifndef __NWDSTYPE_H
#include <nwdstype.h>
#endif

#ifndef _NWDSBUFT_HEADER_
#include <nwdsbuft.h>
#endif

#ifndef	_NWDSDC_HEADER_
#include <nwdsdc.h>
#endif

#ifndef NWCONNECT_INC
#include <nwconnec.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

NWDSCCODE NWAPI	NWDSAddObject
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	int32		NWPTR iterationHandle,
	uint8		more,
	Buf_T		NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSBackupObject
(
	NWDSContextHandle		context,
	char	NWPTR objectName,
	int32	NWPTR iterationHandle,
	Buf_T	NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSCompare
(
	NWDSContextHandle		context,
	char	NWPTR object,
	Buf_T	NWPTR buf,
	uint8	NWPTR matched
);

/*-----------------------------------------------------------------------------
 *		In the case that objectName is a partition root, the partitionRootObject
 *		is the same as the objectName
 */

NWDSCCODE NWAPI	NWDSGetPartitionRoot
(
 	NWDSContextHandle	context,
	char	NWPTR objectName,
	char	NWPTR partitionRoot
);

NWDSCCODE NWAPI NWDSList
(
	NWDSContextHandle		context,
	char		NWPTR object,
	int32		NWPTR iterationHandle,
	Buf_T		NWPTR subordinates
);

NWDSCCODE NWAPI NWDSMapIDToName
(
	NWDSContextHandle		context,
	NWCONN_HANDLE		conn,
	uint32	objectID,
	char		NWPTR object
);

NWDSCCODE NWAPI NWDSMapNameToID
(
	NWDSContextHandle		context,
	NWCONN_HANDLE		conn,
	char		NWPTR object,
	uint32	NWPTR objectID
);

NWDSCCODE NWAPI NWDSModifyObject
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	int32		NWPTR iterationHandle,
	uint8		more,
	Buf_T		NWPTR changes
);

NWDSCCODE NWAPI NWDSModifyDN
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	char		NWPTR newDN,
	uint8		deleteOldRDN
);

NWDSCCODE NWAPI NWDSModifyRDN
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	char		NWPTR newDN,
	uint8		deleteOldRDN
);

NWDSCCODE NWAPI NWDSMoveObject
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	char		NWPTR destParentDN,
	char		NWPTR	destRDN
);

NWDSCCODE NWAPI NWDSRead
(
	NWDSContextHandle		context,
	char		NWPTR object,
	uint32	infoType,
	uint8	   allAttrs,
	Buf_T		NWPTR attrNames,
	int32		NWPTR iterationHandle,
	Buf_T		NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSReadObjectInfo
(
	NWDSContextHandle					context,
	char					NWPTR object,
	char					NWPTR distinguishedName,
	Object_Info_T		NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSRemoveObject
(
	NWDSContextHandle		context,
	char		NWPTR object
);

NWDSCCODE NWAPI NWDSRestoreObject
(
	NWDSContextHandle		context,
	char	NWPTR objectName,
	int32	NWPTR iterationHandle,
	uint8 more,
	uint32 size,
	uint8	NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSSearch
(
	NWDSContextHandle		context,
	char		NWPTR baseObjectName,
	int		scope,
	uint8		searchAliases,
	Buf_T		NWPTR filter,
	uint32	infoType,
	uint8		allAttrs,
	Buf_T		NWPTR attrNames,
	int32		NWPTR iterationHandle,
	int32		countObjectsToSearch,
	int32		NWPTR countObjectsSearched,
	Buf_T		NWPTR objectInfo
);

NWDSCCODE NWAPI NWDSOpenStream
(
	NWDSContextHandle		context,
	char		NWPTR objectName,
	char		NWPTR attrName,
	uint32	flags,
	INT16		NWPTR fileHandle
);

NWDSCCODE NWAPI NWDSWhoAmI
(
 	NWDSContextHandle	context,
	char	NWPTR objectName
);

NWDSCCODE NWAPI NWDSGetServerDN
(
	NWDSContextHandle context,
	NWCONN_HANDLE		conn,
	char NWPTR serverDN
);
						
NWDSCCODE NWAPI NWDSGetServerAddresses
(
	NWDSContextHandle context,
	NWCONN_HANDLE		conn,
	uint32 NWPTR countNetAddress, 
	Buf_T NWPTR netAddresses
);
						


#ifdef __cplusplus
}
#endif

#endif									/* #ifndef _NWDSDSA_HEADER_ */

