/*****************************************************************************
 *
 * Program Name:  Thunking Interface for OS/2 2.x
 *
 * Filename:	   Thunk.h
 *
 * Date Created:  August 10, 1993
 *
 * Date Modified: 11/11/94
 *
 * Modifications: Cleaned up CSET2 support
 *
 * Comments:	   Called from nwcaldef.h
 *
 * COPYRIGHT (c) 1993 by Novell, Inc.  All Rights Reserved.
 *
 * This program is an unpublished copyrighted work which is proprietary
 * to Novell, Inc. and contains confidential information that is not
 * to be reproduced or disclosed to any other person or entity without
 * prior written consent from Novell, Inc. in each and every instance.
 *
 * WARNING:  Unauthorized reproduction of this program as well as
 * unauthorized preparation of derivative works based upon the
 * program or distribution of copies by sale, rental, lease or
 * lending are violations of federal copyright laws and state trade
 * secret laws, punishable by civil and criminal penalties.
 *
 ****************************************************************************/
#ifndef THUNK_INCLUDED
#define THUNK_INCLUDED

#ifndef IS32BIT
// its not 32 bit code, so leave everything alone
#define IS16BIT

#else

// some target OS sizes
#define INT16 short
#define INT32 int
#define NWFAR far

// specific def's by compiler
#ifdef CSET2

#undef NWFAR
#define NWFAR _Far16
#define NWPTR * _Seg16
#define NWAPI _Far16 _Pascal
#define NWPASCAL _Pascal

#else
#ifdef BCPP

#define NWFAR __far16
#define NWPTR __far16 *
#define NWAPI __far16 __pascal 
#define NWPASCAL __pascal

#else
#ifdef WATC

#define NWPTR __far16 *
#define NWAPI __far16 __pascal 
#define NWPASCAL __pascal


#else
// no other 32bit compilers, fall out of here
#endif 
#endif 
#endif 
#endif 


#endif 


